//
// Cognitive engine descriptor
// 

#ifndef __COGNITIVE_ENGINE_H__
#define __COGNITIVE_ENGINE_H__

typedef struct {
    float value;
    char name[64];
} object;

typedef struct ce_s * ce;
struct ce_s {
    // utilities
    object * u;
    unsigned int num_utilities;
    
    // parameters
    object * p;
    unsigned int num_parameters;

    // observables
    object * o;
    unsigned int num_observables;

    char name[64];
};

ce ce_create(char * _xmlfilename /*, engine_type (e.g. CBR) */);
void ce_destroy(ce _engine);
void ce_print(ce _engine);

// TODO add specific commands to take action, store experience

#endif // __COGNITIVE_ENGINE_H__
